<?php

/*
 * This file is part of EC-CUBE
 *
 * Copyright(c) EC-CUBE CO.,LTD. All Rights Reserved.
 *
 * http://www.ec-cube.co.jp/
 *
 * For the full copyright and license information, please view the LICENSE
 * file that was distributed with this source code.
 */

namespace Plugin\ForIbn4203\Controller;

use Eccube\Controller\AbstractController;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\Route;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\Template;
use Symfony\Component\HttpFoundation\Request;
use Eccube\Repository\ProductRepository;

class Ibn4203NewItemController extends AbstractController
{
    /**
     * HelpController constructor.
     */
    public function __construct()
    {
    }

    /**
     * 新着商品.
     * @Route("/block/new_item", name="block_new_item")
     * @Template("Block/new_item.twig")
     */
    public function index(Request $request, ProductRepository $productRepository)
    {
        $qb = $productRepository->createQueryBuilder('p')
            ->where('p.Status = 1')
            ->setMaxResults(10);

        if (0 == 0) {
            $qb = $qb
                ->addOrderBy('p.create_date', 'DESC')
                ->addOrderBy('p.id', 'DESC');
        }  else {
            $qb = $qb
                ->addOrderBy('p.update_date', 'DESC');
        }

        $NewItem = $qb->getQuery()->getResult();

		return [
            'NewItem' => $NewItem,
		];
    }

}
