<?php

/*
 * This file is part of EC-CUBE
 *
 * Copyright(c) LOCKON CO.,LTD. All Rights Reserved.
 *
 * http://www.lockon.co.jp/
 *
 * For the full copyright and license information, please view the LICENSE
 * file that was distributed with this source code.
 */

namespace Plugin\ForIbn4203\Repository;

use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\Common\Collections\Criteria;
use Doctrine\DBAL\Exception\DriverException;
use Doctrine\DBAL\Exception\ForeignKeyConstraintViolationException;
use Plugin\ForIbn4203\Entity\Ibn4203Topic;
use Doctrine\Persistence\ManagerRegistry as RegistryInterface;
use Eccube\Repository\AbstractRepository;

/**
 * Ibn4203TopicRepository
 *
 * This class was generated by the Doctrine ORM. Add your own custom
 * repository methods below.
 */
class Ibn4203TopicRepository extends AbstractRepository
{
    public function __construct(RegistryInterface $registry)
    {
        parent::__construct($registry, Ibn4203Topic::class);
    }

    /**
     * 登録
     *
     * @param $Ibn4203Topic
     */
    public function save($Ibn4203Topic)
    {
        $em = $this->getEntityManager();
        $em->persist($Ibn4203Topic);
        $em->flush($Ibn4203Topic);
    }

    /**
     * 削除
     *
     * @param Ibn4203Topic $Ibn4203Topic
     *
     * @throws ForeignKeyConstraintViolationException 外部キー制約違反の場合
     * @throws DriverException SQLiteの場合, 外部キー制約違反が発生すると, DriverExceptionをthrowします.
     */
    public function delete($Ibn4203Topic)
    {
        $em = $this->getEntityManager();
        $em->remove($Ibn4203Topic);
        $em->flush($Ibn4203Topic);
    }

    /**
     * @return \Doctrine\ORM\QueryBuilder
     */
    public function getQueryBuilderAll()
    {
        $qb = $this->createQueryBuilder('n');
        $qb->orderBy('n.sort_no', 'DESC');

        return $qb;
    }

    /**
     * @return Ibn4203Topic[]|ArrayCollection
     */
    public function getList()
    {
        // second level cacheを効かせるためfindByで取得
        $Results = $this->findBy(['visible' => true], ['sort_no' => 'DESC', 'id' => 'DESC']);

        $Ibn4203Topics = new ArrayCollection($Results);

        return $Ibn4203Topics;
    }
}
